function main_recovery()

% categoryName = 'forest_test_10000';
% model_file = '../forest_501_model.mat';
categoryName = 'face10000';
% model_file = '../iter_401_model.mat';
model_file = '../32mask_121_model.mat';

TaskName = 'pepper_4_0.8';   % Tasks: doodle, doodle_mix, m32, pepper_1_0.9, pepper_3_0.9, pepper_4_0.8, pepper_8_0.6, pepper_8_0.4

saveLast = true;
numSelectedImages = 1000; % 1000


%% methods
method.runCoopNet = 0;
method.runMRF = 1;
method.runNAN = 0;

%%
[config, net1, net2, imdb, getBatch, imdb_ori, getBatch_ori]=recovery_config(categoryName,TaskName,model_file, numSelectedImages, method);

%%

mean_img1 = net1.normalization.averageImage;
mean_img2 = net2.normalization.averageImage;

net1 = vl_simplenn_move(net1, 'gpu');
net2 = vl_simplenn_move(net2, 'gpu');


train = find(imdb.images.set==1);
num_batch = numel(1:config.batch_size:numel(train));

if method.runCoopNet
    loss1 = zeros(num_batch, config.RecoveryNumStep_net1);
    psnr1_all = zeros(num_batch,1);
    psnr1_mask = zeros(num_batch,1);
    ssim1_all = zeros(num_batch,1);
    ssim1_mask = zeros(num_batch,1);
    
    
    loss2 = zeros(num_batch, config.RecoveryNumStep_net2);
    psnr2_all = zeros(num_batch,1);
    psnr2_mask = zeros(num_batch,1);
    ssim2_all = zeros(num_batch,1);
    ssim2_mask = zeros(num_batch,1);
end

if method.runMRF
    error_mrfl2 = zeros(num_batch,1);
    psnr_all_mrfl2 = zeros(num_batch,1);
    psnr_mask_mrfl2 = zeros(num_batch,1);
    ssim_all_mrfl2 = zeros(num_batch,1);
    ssim_mask_mrfl2 = zeros(num_batch,1);
    
    
    error_mrfl1 = zeros(num_batch,1);
    psnr_all_mrfl1 = zeros(num_batch,1);
    psnr_mask_mrfl1 = zeros(num_batch,1);
    ssim_all_mrfl1 = zeros(num_batch,1);
    ssim_mask_mrfl1 = zeros(num_batch,1);
end

if method.runNAN
    error_nan1 = zeros(num_batch,1);
    psnr_all_nan1 = zeros(num_batch,1);
    psnr_mask_nan1 = zeros(num_batch,1);
    ssim_all_nan1 = zeros(num_batch,1);
    ssim_mask_nan1 = zeros(num_batch,1);
    
    
    error_nan2 = zeros(num_batch,1);
    psnr_all_nan2 = zeros(num_batch,1);
    psnr_mask_nan2 = zeros(num_batch,1);
    ssim_all_nan2 = zeros(num_batch,1);
    ssim_mask_nan2 = zeros(num_batch,1);
    
    error_nan3 = zeros(num_batch,1);
    psnr_all_nan3 = zeros(num_batch,1);
    psnr_mask_nan3 = zeros(num_batch,1);
    ssim_all_nan3 = zeros(num_batch,1);
    ssim_mask_nan3 = zeros(num_batch,1);
    
    error_nan4 = zeros(num_batch,1);
    psnr_all_nan4 = zeros(num_batch,1);
    psnr_mask_nan4 = zeros(num_batch,1);
    ssim_all_nan4 = zeros(num_batch,1);
    ssim_mask_nan4 = zeros(num_batch,1);
    
    error_nan5 = zeros(num_batch,1);
    psnr_all_nan5 = zeros(num_batch,1);
    psnr_mask_nan5 = zeros(num_batch,1);
    ssim_all_nan5 = zeros(num_batch,1);
    ssim_mask_nan5 = zeros(num_batch,1);
    
    error_nan0 = zeros(num_batch,1);
    psnr_all_nan0 = zeros(num_batch,1);
    psnr_mask_nan0 = zeros(num_batch,1);
    ssim_all_nan0 = zeros(num_batch,1);
    ssim_mask_nan0 = zeros(num_batch,1);
end


for t=1:config.batch_size:numel(train)
    
    
    i_batch=((t-1)/config.batch_size)+1;
    fprintf('recovering: batch %3d/%3d: \n', ...
        i_batch, ceil(numel(train)/config.batch_size)) ;
    
    batch_folder=[config.Synfolder, 'batch_', num2str(i_batch) '/'];
    if ~exist(batch_folder, 'dir')
        mkdir(batch_folder)
    end
    
    for s=1:1
        batchStart = t + (labindex-1) + (s-1) * numlabs ;
        batchEnd = min(t+config.batch_size-1, numel(train)) ;
        batch = train(batchStart : 1 * numlabs : batchEnd) ;
        
        [im, ~, mask] = getBatch(imdb, batch) ;
        im_ori = getBatch_ori(imdb_ori, batch);
        
        
        I_ori = convert_syns_mat(config, mean_img1, im_ori);
        I_masked = convert_syns_mat(config, mean_img1, im);
        
        imwrite(I_ori,[batch_folder, 'original.png']);
        imwrite(I_masked,[batch_folder, 'masked.png']);
        
        
        im = gpuArray(im);
        mask = gpuArray(mask);
        im_ori = gpuArray(im_ori);
      
        
        if method.runMRF
            % mrf_l2
            [error_mrfl2(i_batch), psnr_all_mrfl2(i_batch), psnr_mask_mrfl2(i_batch), ssim_all_mrfl2(i_batch), ssim_mask_mrfl2(i_batch)] ...
                = recover_mrf_fast(im, im_ori, mask, config.figure_folder_mrfl2, i_batch, 1);
            
            % mrf_l1
            [error_mrfl1(i_batch), psnr_all_mrfl1(i_batch), psnr_mask_mrfl1(i_batch), ssim_all_mrfl1(i_batch), ssim_mask_mrfl1(i_batch)] ...
                = recover_mrf_fast(im, im_ori, mask, config.figure_folder_mrfl1, i_batch, 2);
        end
        
        
        if method.runNAN
            % nan1
            disp('image recovery by NAN1');
            [error_nan1(i_batch), psnr_all_nan1(i_batch), psnr_mask_nan1(i_batch), ssim_all_nan1(i_batch), ssim_mask_nan1(i_batch)] ...
                = recover_nan(im, im_ori, mask, config.figure_folder_nan1, i_batch, 1);
            %
            % nan2
            disp('image recovery by NAN2');
            [error_nan2(i_batch), psnr_all_nan2(i_batch), psnr_mask_nan2(i_batch), ssim_all_nan2(i_batch), ssim_mask_nan2(i_batch)] ...
                = recover_nan(im, im_ori, mask, config.figure_folder_nan2, i_batch, 2);
            
            % nan3
            disp('image recovery by NAN3');
            [error_nan3(i_batch), psnr_all_nan3(i_batch), psnr_mask_nan3(i_batch), ssim_all_nan3(i_batch), ssim_mask_nan3(i_batch)] ...
                = recover_nan(im, im_ori, mask, config.figure_folder_nan3, i_batch, 3);
            
            % nan4
            disp('image recovery by NAN4');
            [error_nan4(i_batch), psnr_all_nan4(i_batch), psnr_mask_nan4(i_batch), ssim_all_nan4(i_batch), ssim_mask_nan4(i_batch)] ...
                = recover_nan(im, im_ori, mask, config.figure_folder_nan4, i_batch, 4);
            
            % nan5
            disp('image recovery by NAN5');
            [error_nan5(i_batch), psnr_all_nan5(i_batch), psnr_mask_nan5(i_batch), ssim_all_nan5(i_batch), ssim_mask_nan5(i_batch)] ...
                = recover_nan(im, im_ori, mask, config.figure_folder_nan5, i_batch, 5);
            
            % nan0
            disp('image recovery by NAN0');
            [error_nan0(i_batch), psnr_all_nan0(i_batch), psnr_mask_nan0(i_batch), ssim_all_nan0(i_batch), ssim_mask_nan0(i_batch)] ...
                = recover_nan(im, im_ori, mask, config.figure_folder_nan0, i_batch, 0);
        end

        
        fid = fopen([config.figure_folder 'batch_' num2str(i_batch) '_error.txt'], 'w');
        
        if method.runCoopNet
            fprintf(fid, 'loss2 %.4f\n', loss2(i_batch,end));
            fprintf(fid, 'psnr2_mask %.4f\n', psnr2_mask(i_batch) );
            fprintf(fid, 'psnr2_all %.4f\n', psnr2_all(i_batch) );
            fprintf(fid, 'ssim2_mask %.4f\n', ssim2_mask(i_batch) );
            fprintf(fid, 'ssim2_all %.4f\n\n', ssim2_all(i_batch) );
            
            fprintf(fid, 'loss1 %.4f\n', loss1(i_batch,end));
            fprintf(fid, 'psnr1_mask %.4f\n', psnr1_mask(i_batch) );
            fprintf(fid, 'psnr1_all %.4f\n', psnr1_all(i_batch) );
            fprintf(fid, 'ssim1_mask %.4f\n', ssim1_mask(i_batch) );
            fprintf(fid, 'ssim1_all %.4f\n\n', ssim1_all(i_batch) );
        end
        
        if method.runMRF
            fprintf(fid, 'mrfl2 %.4f\n', error_mrfl2(i_batch));
            fprintf(fid, 'psnr_mask_mrfl2 %.4f\n', psnr_mask_mrfl2(i_batch));
            fprintf(fid, 'psnr_all_mrfl2 %.4f\n', psnr_all_mrfl2(i_batch));
            fprintf(fid, 'ssim_mask_mrfl2 %.4f\n', ssim_mask_mrfl2(i_batch));
            fprintf(fid, 'ssim_all_mrfl2 %.4f\n\n', ssim_all_mrfl2(i_batch));
            
            fprintf(fid, 'mrfl1 %.4f\n', error_mrfl1(i_batch));
            fprintf(fid, 'psnr_mask_mrfl1 %.4f\n', psnr_mask_mrfl1(i_batch));
            fprintf(fid, 'psnr_all_mrfl1 %.4f\n', psnr_all_mrfl1(i_batch));
            fprintf(fid, 'ssim_mask_mrfl1 %.4f\n', ssim_mask_mrfl1(i_batch));
            fprintf(fid, 'ssim_all_mrfl1 %.4f\n\n', ssim_all_mrfl1(i_batch));
        end
        
        if method.runNAN
            fprintf(fid, 'nan1 %.4f\n', error_nan1(i_batch));
            fprintf(fid, 'psnr_mask_nan1 %.4f\n', psnr_mask_nan1(i_batch));
            fprintf(fid, 'psnr_all_nan1 %.4f\n', psnr_all_nan1(i_batch));
            fprintf(fid, 'ssim_mask_nan1 %.4f\n', ssim_mask_nan1(i_batch));
            fprintf(fid, 'ssim_all_nan1 %.4f\n\n', ssim_all_nan1(i_batch));
            
            fprintf(fid, 'nan2 %.4f\n', error_nan2(i_batch));
            fprintf(fid, 'psnr_mask_nan2 %.4f\n', psnr_mask_nan2(i_batch));
            fprintf(fid, 'psnr_all_nan2 %.4f\n', psnr_all_nan2(i_batch));
            fprintf(fid, 'ssim_mask_nan2 %.4f\n', ssim_mask_nan2(i_batch));
            fprintf(fid, 'ssim_all_nan2 %.4f\n\n', ssim_all_nan2(i_batch));
            
            fprintf(fid, 'nan3 %.4f\n', error_nan3(i_batch));
            fprintf(fid, 'psnr_mask_nan3 %.4f\n', psnr_mask_nan3(i_batch));
            fprintf(fid, 'psnr_all_nan3 %.4f\n', psnr_all_nan3(i_batch));
            fprintf(fid, 'ssim_mask_nan3 %.4f\n', ssim_mask_nan3(i_batch));
            fprintf(fid, 'ssim_all_nan3 %.4f\n\n', ssim_all_nan3(i_batch));
            
            fprintf(fid, 'nan4 %.4f\n', error_nan4(i_batch));
            fprintf(fid, 'psnr_mask_nan4 %.4f\n', psnr_mask_nan4(i_batch));
            fprintf(fid, 'psnr_all_nan4 %.4f\n', psnr_all_nan4(i_batch));
            fprintf(fid, 'ssim_mask_nan4 %.4f\n', ssim_mask_nan4(i_batch));
            fprintf(fid, 'ssim_all_nan4 %.4f\n\n', ssim_all_nan4(i_batch));
            
            fprintf(fid, 'nan5 %.4f\n', error_nan5(i_batch));
            fprintf(fid, 'psnr_mask_nan5 %.4f\n', psnr_mask_nan5(i_batch));
            fprintf(fid, 'psnr_all_nan5 %.4f\n', psnr_all_nan5(i_batch));
            fprintf(fid, 'ssim_mask_nan5 %.4f\n', ssim_mask_nan5(i_batch));
            fprintf(fid, 'ssim_all_nan5 %.4f\n\n', ssim_all_nan5(i_batch));
            
            fprintf(fid, 'nan0 %.4f\n', error_nan0(i_batch));
            fprintf(fid, 'psnr_mask_nan0 %.4f\n', psnr_mask_nan0(i_batch));
            fprintf(fid, 'psnr_all_nan0 %.4f\n', psnr_all_nan0(i_batch));
            fprintf(fid, 'ssim_mask_nan0 %.4f\n', ssim_mask_nan0(i_batch));
            fprintf(fid, 'ssim_all_nan0 %.4f\n\n', ssim_all_nan0(i_batch));
        end
               
        fclose(fid);
        
    end
end

save([config.figure_folder TaskName '_all.mat']);

net1 = vl_simplenn_move(net1, 'cpu');
net2 = vl_simplenn_move(net2, 'cpu');

