function [img_mat_original, img_mat_masked, masks] = read_masked_images(config, net, numSelectedImages)


if exist(config.mask_file)
    load(config.mask_file);
else
    error('No mask files');
end

%img_file = [config.inPath, '/images.mat'];

files = dir([config.inPath '/*.jpg']);

if isempty(files)
   files = dir([config.inPath '/*.JPEG']); 
end
if isempty(files)
   files = dir([config.inPath '/*.png']); 
end

if isempty(files)
   fprintf('error: No masked images are found\n');
   keyboard;
end


numImages=min(numSelectedImages,length(files));

files = files(1:numImages);
masks = masks(:,:,:,1:numImages);
masks = (masks == 1);

img_mat_original = zeros([64, 64, 3, length(files)], 'single');
for iImg = 1:length(files)    
    %iImg
    img = imread(fullfile(config.inPath, files(iImg).name));
    img = imresize(img, [64, 64]);
    if size(img,3)==1
        img = cat(3, img, img, img);
    end
%     img = imresize(img, [net.normalization.imageSize(1),net.normalization.imageSize(2)]);
    img = single(img);
    img_mat_original(:,:,:,iImg) = 2*(img - min(img(:)))/(max(img(:))-min(img(:)))-1 ;
end

img_mat_masked=img_mat_original;
img_mat_masked(masks==1) = 0;


% numImages = 0;
% 
% if exist(img_file, 'file') && ~config.force_learn
%     load(img_file);
%     load([config.inPath, '/masks.mat'])
%     numImages = size(img_mat, 4);
% end
% 
% if numImages ~= length(files) || config.force_learn == true;
%     load([config.inPath, '/masks.mat'])
%     img_mat = zeros([net.normalization.imageSize, length(files)], 'single');
%     for iImg = 1:length(files)
%         
%         img = single(imread(fullfile(config.inPath, files(iImg).name)));
%         img_mat(:,:,:,iImg) = 2*(img - min(img(:)))/(max(img(:))-min(img(:)))-1 ;
%     end
%     save(img_file, 'img_mat');
% end