function [error, psnr_all, psnr_mask, ssim_all, ssim_mask] = recover_nan(im, im_ori, masks, save_dir, batchID, method)
if ~exist(save_dir, 'dir')
    mkdir(save_dir);
end

error = 0;

psnr_all =0;
psnr_mask = 0;

ssim_all = 0;
ssim_mask = 0;

im = gather(im);
masks = gather(masks);
im_ori = gather(im_ori);

for i = 1:size(im, 4)
    
    
    img = (im(:,:,:,i)+1)/2 * 255;
    img = double(img);
    mask = masks(:,:,:, i);
    img(mask==1) = NaN;
    
    img(:,:,1) = inpaint_nans(img(:,:,1), method);
    img(:,:,2) = inpaint_nans(img(:,:,2), method);
    img(:,:,3) = inpaint_nans(img(:,:,3), method);
    
    img = max(0, img);
    img = min(255, img);
    
    img = single(img/255 * 2 -1);
    
    img_ori = im_ori(:,:,:,i);
    
    img = (img - min(img(:))) / (max(img(:)) - min(img(:)));   
    imwrite(img, [save_dir, 'batch_', num2str(batchID), num2str(i, '_recover_%04d.png')]);
   
    re_img_255=uint8(img*255);
    
    img1 = (img_ori - min(img_ori(:))) / (max(img_ori(:)) - min(img_ori(:)));
    ori_img_255=uint8(img1*255);
    
    error_temp=mean(reshape(abs(re_img_255(mask==1) - ori_img_255(mask==1)), [], 1));    
    error = error + error_temp;    
    
    psnr_all = psnr_all + psnr(re_img_255, ori_img_255);
    psnr_mask = psnr_mask + psnr(re_img_255(mask), ori_img_255(mask));
    
    ssim_all = ssim_all + ssim(re_img_255, ori_img_255);
    ssim_mask = ssim_mask + ssim(re_img_255(mask), ori_img_255(mask));   
    
    disp(['image', num2str(i)]);    
    
end

error = (error/255.0) / size(im, 4);
psnr_all = psnr_all / size(im, 4);
psnr_mask = psnr_mask / size(im, 4);
ssim_all = ssim_all / size(im, 4);
ssim_mask = ssim_mask / size(im, 4);
