function [config, net1, net2, imdb_masked, getBatch_masked, imdb_ori, getBatch_ori]=recovery_config(categoryName,TaskName,model_file,numSelectedImages, method)

if ~exist(model_file)
    error('No model file');
else
    model=load(model_file);
end

net1=model.net1;
net2=model.net2;
config=model.opts;


inPath = ['../', categoryName];
mask_file = ['../', TaskName, '_masks.mat'];
Synfolder = ['./synthesiedImage/', categoryName,  '/', TaskName, '/'];
figure_folder = ['./result/', categoryName, '/', TaskName, '/'];

addpath(genpath('./core/') )
if ~exist('./synthesiedImage/', 'dir')
   mkdir('./synthesiedImage/') 
end

if ~exist(Synfolder, 'dir')
   mkdir(Synfolder);
end

if ~exist(figure_folder, 'dir')
    mkdir(figure_folder);
end
%datatype = 'celebB';
%config = frame_config('face_30', 'mask', 'object');

config.mask_file = mask_file;
config.Synfolder = Synfolder;
config.figure_folder = figure_folder;


config.figure_folder_original = [config.figure_folder 'original/'];
if ~exist(config.figure_folder_original, 'dir')
    mkdir(config.figure_folder_original);
end

if method.runCoopNet
    config.figure_folder_generator = [config.figure_folder 'net2/'];
    config.figure_folder_generator_descriptor = [config.figure_folder 'net2_and_1/'];
    
    if ~exist(config.figure_folder_generator, 'dir')
        mkdir(config.figure_folder_generator);
    end    
        
    if ~exist(config.figure_folder_generator_descriptor, 'dir')
        mkdir(config.figure_folder_generator_descriptor);
    end
end

if method.runMRF
    config.figure_folder_mrfl2 = [config.figure_folder 'mrfl2/'];
    config.figure_folder_mrfl1 = [config.figure_folder 'mrfl1/'];
    
    if ~exist(config.figure_folder_mrfl2, 'dir')
        mkdir(config.figure_folder_mrfl2);
    end
    
    if ~exist(config.figure_folder_mrfl1, 'dir')
        mkdir(config.figure_folder_mrfl1);
    end
end

if method.runNAN
    config.figure_folder_nan1 = [config.figure_folder 'nan1/'];
    config.figure_folder_nan2 = [config.figure_folder 'nan2/'];
    config.figure_folder_nan3 = [config.figure_folder 'nan3/'];
    config.figure_folder_nan4 = [config.figure_folder 'nan4/'];
    config.figure_folder_nan5 = [config.figure_folder 'nan5/'];
    config.figure_folder_nan0 = [config.figure_folder 'nan0/'];
        
    if ~exist(config.figure_folder_nan1, 'dir')
        mkdir(config.figure_folder_nan1);
    end
    
    if ~exist(config.figure_folder_nan2, 'dir')
        mkdir(config.figure_folder_nan2);
    end
    
    if ~exist(config.figure_folder_nan3, 'dir')
        mkdir(config.figure_folder_nan3);
    end
    
    if ~exist(config.figure_folder_nan4, 'dir')
        mkdir(config.figure_folder_nan4);
    end
    
    if ~exist(config.figure_folder_nan5, 'dir')
        mkdir(config.figure_folder_nan5);
    end
    
    if ~exist(config.figure_folder_nan0, 'dir')
        mkdir(config.figure_folder_nan0);
    end
end


config.inPath = inPath;
%config.datatype = datatype;
config.is_crop = false;
config_ori.is_preprocess = false;

%config.T = 300;
config.RecoveryNumStep_net1= 400;
config.nTileRow = 10;
config.nTileCol = 10;
config.batch_size = config.nTileRow * config.nTileCol;
config.Delta1 = 0.0001; % 0.0003;

config.Delta2 = 0.03;
config.RecoveryNumStep_net2 = 700;

%% read masked images
[img_mat_original, img_mat_masked, masks] = read_masked_images(config, net1, numSelectedImages);

[imdb_masked, getBatch_masked] = convert2imdb(img_mat_masked, masks);
[imdb_ori, getBatch_ori] = convert2imdb(img_mat_original);

%[imdb, getBatch] = create_imdb(config, net1);

% %% read original images
% config_ori = config;
% config_ori.inPath = ['./data/', categoryName, '/original'];
% config_ori.force_learn = true;
% config_ori.is_crop = false;
% config_ori.is_preprocess = false;
% [img_mat, net1] = read_images2(config_ori, net1);
% [imdb_ori, getBatch_ori] = convert2imdb(img_mat);


%[imdb_ori, getBatch_ori] = create_imdb(config_ori, net1);
