function [I_syn, syn_mat] = convert_syns_mat(config, mean_img, syn_mat, mask, prefix)

space = 5;

color = 0;

for i = 1:size(syn_mat, 4)
    if sum( abs(mean_img(:))) ~= 0
        syn_mat(:,:,:,i) = uint8(syn_mat(:,:,:,i) + mean_img);
    end
    % For inpainting propose, only the masked part needs to be scaled
    mask_it = mask(:,:,:,i);
    syn_mat(:,:,:,i) = single(syn_mat(:,:,:,i));
    back_up = syn_mat(:,:,:,i)/255;
    gLow = min( reshape(syn_mat(:,:,:,i), [],1));
    gHigh = max(reshape(syn_mat(:,:,:,i), [],1));
    if config.scale_onlymask
        temp_mat = syn_mat(:,:,:,i);
        temp_mat = temp_mat(mask_it==1);
        gLow = min( reshape(temp_mat, [],1));
        gHigh = max(reshape(temp_mat, [],1));
    end
    syn_mat(:,:,:,i) = (syn_mat(:,:,:,i)-gLow) / (gHigh - gLow);
    temp_mat = syn_mat(:,:,:,i);
    temp_mat(mask_it == 0) = back_up(mask_it == 0);
    syn_mat(:,:,:,i) = temp_mat;
%     if strcmp(prefix, 'original_')
%         temp_mat(mask_it == 1) = 0;
%         syn_mat(:,:,:,i) = temp_mat;
%     end
end

I_syn = mat2canvas(syn_mat, config, space);


for row = 1:config.nTileRow-1
    I_syn(row * config.sx + (row-1) * space + 1:row * config.sx + (row-1) * space + space, :, :) = color;
end

for col = 1:config.nTileCol-1
    I_syn(:, col * config.sy + (col-1) * space + 1:col * config.sy + (col-1) * space + space, :) = color;
end
end