load('/home/rqg/Documents/WorkingSpace/multigrid_multi/working/vehicle1000_multi/iter_341_model.mat')
opts.datatype = 'discriminator';
[imdb, getBatch, ~] = create_imdb(opts, net3);
opts.num_img = 10;

opts.train = [] ;
opts.val = [] ;
opts.conserveMemory = true ;
opts.backPropDepth = +inf ;
opts.sync = false ;
opts.prefetch = false;
opts.cudnn = true ;
opts.weightDecay = 0.0001 ; %0.0001
if isempty(opts.train), opts.train = find(imdb.images.set==1) ; end
subset = opts.train;

% move CNN to GPU as needed
net1 = vl_simplenn_move(net1, 'gpu') ;
net2 = vl_simplenn_move(net2, 'gpu') ;
net3 = vl_simplenn_move(net3, 'gpu') ;

num_cell = ceil(numel(subset) / opts.batch_size) * numel(opts.gpus);
Feature = [];

img_scale = opts.res(2)/opts.res(1);
Q = zeros(img_scale, img_scale, 3, 'single');
Q(:,:,1,1) = 1/img_scale/img_scale;
Q(:,:,2,2) = 1/img_scale/img_scale;
Q(:,:,3,3) = 1/img_scale/img_scale;
Q = gpuArray(Q);

% build filter Q^(-1)
Q_inv = zeros(img_scale, img_scale, 3, 'single');
Q_inv(:,:,1,1) = 1;
Q_inv(:,:,2,2) = 1;
Q_inv(:,:,3,3) = 1;
Q_inv = gpuArray(Q_inv);

Q_dummy = zeros(1, 3, 'single');
Q_dummy = gpuArray(Q_dummy);

for t=1:opts.batch_size:numel(subset)
    fprintf('training: epoch %02d: batch %3d/%3d: \n', epoch, ...
        fix(t/opts.batch_size)+1, ceil(numel(subset)/opts.batch_size)) ;
    batchSize = min(opts.batch_size, numel(subset) - t + 1) ;
    opts.batchSize = batchSize;
    
    % get this image batch and prefetch the next
    batchStart = t;
    batchEnd = min(t+opts.batch_size-1, numel(subset)) ;
    batch = subset(batchStart : batchEnd) ;
    im = getBatch(imdb, batch) ;
    im = gpuArray(im);
    
    % prepare derative
    
    cell_idx = (ceil(t / opts.batch_size) - 1) * numlabs + labindex;    
    
    res = vl_simplenn(net, syn_mat, dydz, res, ...
            'accumulate', false, ...
            'disableDropout', false, ...
            'conserveMemory', opts.conserveMemory, ...
            'backPropDepth', opts.backPropDepth, ...
            'sync', opts.sync, ...
            'cudnn', opts.cudnn);
    syn_mats1{cell_idx} = gather(syn_mat1);   
    
end

net1 = vl_simplenn_move(net1, 'cpu') ;
net2 = vl_simplenn_move(net2, 'cpu') ;
net3 = vl_simplenn_move(net3, 'cpu') ;

